﻿
using System;
using Wisej.Core;
using Wisej.Web;

namespace Wisej.ApplicationEventFilter
{
	public partial class Page1 : Page, IEventFilter
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			if (this.listBox1.Items.Count > 100)
				this.listBox1.Items.RemoveAt(0);

			this.listBox1.SelectedIndex = 
				this.listBox1.Items.Add("Tick: " + DateTime.Now.ToLongTimeString());
		}

		private void button1_Click(object sender, EventArgs e)
		{
			this.listBox1.Items.Add("<span style='color:red'>Start Processing Click....</span>");

			System.Threading.Thread.Sleep(5000);

			this.listBox1.Items.Add("<span style='color:red'>End Processing Click....</span>");
		}

		private void checkBox1_CheckedChanged(object sender, EventArgs e)
		{
			if (this.checkBox1.Checked)
			{
				// you can use any instance that implements IEventFilter.
				Application.AddEventFilter(this);
			}
			else
			{
				Application.RemoveEventFilter(this);
			}
		}

		bool IEventFilter.PreFilterEvent(WisejEventArgs e)
		{
			switch(e.Type)
			{
				case "interval":

					if (this._inExecute)
						return true; // handled

					break;

				case "execute":

					// block timer events while processing the "execute" event, which corresponds to a
					// click on a button, radio button, etc.
					if (!this._inExecute)
					{
						this._inExecute = true;
						try
						{
							e.Target.Event(e);
						}
						finally
						{
							this._inExecute = false;
						}
					}

					// prevent the default implementation from dispatching the event.
					return true; // handled
			}

			return false;
		}

		private bool _inExecute;
	}
}
